#include "TRAEEvent.h"
#include "TRAEParticle.h"
#include "TStreamerInfo.h"
#include "TBuffer.h"

ClassImp(TRAEEvent)

TRAEEvent::TRAEEvent()
{
	fParticles = new TClonesArray("TRAEParticle",10);
	TStreamerInfo::SetCanDelete(kFALSE);
	fParticles->BypassStreamer(kFALSE);
}

TRAEEvent::~TRAEEvent()
{
	fParticles->Delete();
	delete fParticles;
	fParticles = 0;
}

TRAEParticle* TRAEEvent::AddParticle()
{
	// add a new particle to event and return its address
	
	Int_t mult = fParticles->GetEntriesFast();
	return (TRAEParticle*)fParticles->New(mult);
}

void TRAEEvent::Clear(Option_t * opt)
{
   // Reset the event to zero ready for new event.

   fParticles->Clear("C");
}

void TRAEEvent::Print(Option_t * t) const
{
   // Print list of all particles in the event

	Int_t mult = fParticles->GetEntriesFast();
	Info("Print","Event with %d particles :", mult);
	TIter next_p(fParticles);TObject*part;
	while( (part = next_p()) ) part->Print();
}

//______________________________________________________________________________
void TRAEEvent::Streamer(TBuffer &R__b)
{
   // Stream an object of class TRAEEvent.

	Info("Streamer","Called");
   if (R__b.IsReading()) {
      R__b.ReadClassBuffer(TRAEEvent::Class(),this);
   } else {
      R__b.WriteClassBuffer(TRAEEvent::Class(),this);
   }
}
